% Created 2015-09-02 Wed 14:20
\documentclass[nowasysym]{beamer}
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{fixltx2e}
\usepackage{graphicx}
\usepackage{longtable}
\usepackage{float}
\usepackage{wrapfig}
\usepackage{soul}
\usepackage{textcomp}
\usepackage{marvosym}
\usepackage{wasysym}
\usepackage{latexsym}
\usepackage{amssymb}
\usepackage{hyperref}
\tolerance=1000
\usepackage{color}
\usepackage{listings}
\usepackage{color}
\usepackage{xcolor}
\usepackage{listings}
\input{lmybeamer}
\AtBeginSection[]{}
\hypersetup{pdfcreator=Erwan Jahier,pdfnewwindow=true}
\usepackage{version}
\AtBeginSection[]{}
\hypersetup{pdfcreator=Erwan Jahier,pdfnewwindow=true}
\providecommand{\alert}[1]{\textbf{#1}}

\title{\href{http://www-verimag.imag.fr/DIST-TOOLS/SYNCHRONE/lurette/doc/lutin-tuto/lutin-tuto-pdf.pdf}{A Lutin Tutorial}}
\author{\href{http://www-verimag.imag.fr/DIST-TOOLS/SYNCHRONE/lurette/doc/lutin-tuto/grille.pdf}{Erwan Jahier}}
\date{\today}
\hypersetup{
  pdfkeywords={},
  pdfsubject={},
  pdfcreator={Emacs Org-mode version 7.9.3f}}

\usefonttheme{structurebold}
\begin{document}

\maketitle

\begin{frame}
\frametitle{Outline}
\setcounter{tocdepth}{2}
\tableofcontents
\end{frame}
\section{Forewords}
\label{sec-1}
\begin{frame}
\frametitle{Motivations: testing reactive programs}
\label{sec-1-1}


\input{demarche-it-en}
\end{frame}
\begin{frame}
\frametitle{Lutin in one slide}
\label{sec-1-2}


\begin{itemize}
\item Lustre-like: Dataflow, parallelism, modular, logic time, \texttt{pre}.
\item But not exactly Lustre though
\begin{itemize}
\item Plus
\begin{itemize}
\item \textbf{Control structure} operators (regular expressions)
\item \textbf{Stochastic} (controlled and pseudo-Aleatory)
\end{itemize}
\item Minus
\begin{itemize}
\item No implicit top-level loop
\item No topological sort of equations
\end{itemize}
\end{itemize}
\end{itemize}
\end{frame}
\begin{frame}[fragile]
\frametitle{In order to run this tutorial}
\label{sec-1-3}


\begin{itemize}
\item You will need to install
\begin{itemize}
\item \href{http://www-verimag.imag.fr/DIST-TOOLS/SYNCHRONE/lurette/download.html}{Lutin}
\item Tcl/tk
\item Gnuplot
\end{itemize}
\item you'll find on the Verimag website
\begin{itemize}
\item The \href{http://www-verimag.imag.fr/DIST-TOOLS/SYNCHRONE/lurette/download.html}{tools}
\end{itemize}
\end{itemize}
\begin{itemize}
\item An \href{http://www-verimag.imag.fr/DIST-TOOLS/SYNCHRONE/lurette/lutin-tuto-html.html}{htlm wordier version of those slides}
\end{itemize}

nb : in order to run the demo from the pdf slides 
you can edit your \texttt{.xpdfrc} resource
file modify the \texttt{urlCommand} rule:


\lstset{language=sh}
\begin{lstlisting}
urlCommand      "browserhook.sh '%s'"
\end{lstlisting}

and make the bash script \href{http://www-verimag.imag.fr/DIST-TOOLS/SYNCHRONE/lurette/sh/browserhook.sh}{browserhook.sh}  executable and available from your path
\end{frame}
\section{Execute Lutin programs}
\label{sec-2}
\begin{frame}
\frametitle{Stimulate Lutin programs}
\label{sec-2-1}
\begin{itemize}

\item A program that increments its input\\
\label{sec-2-1-1}%
Let's consider the following Lutin program named \href{file://../incr.lut}{incr.lut}.
CANNOT INCLUDE FILE ./incr.lut



\href{file:./sh/incr-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin incr.lut}}} 


\pause

\item A program with no input\\
\label{sec-2-1-2}%
Consider the \href{file://../one.lut}{one.lut} program:
CANNOT INCLUDE FILE ./one.lut



\href{file:./sh/one-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin -l 5 one.lut}}} 


\pause


\item Be quiet\\
\label{sec-2-1-3}%
\href{file:./sh/one-q-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin -l 5 -quiet one.lut}}} 


\pause

\end{itemize} % ends low level
\end{frame}
\begin{frame}[fragile]
\frametitle{Stimulate Lutin programs graphically with \verb~luciole~}
\label{sec-2-2}


CANNOT INCLUDE FILE ./N.lut



\href{file:./sh/incr-luciole-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin -luciole incr.lut}}} 
\end{frame}
\begin{frame}[fragile]
\frametitle{Store and Display the produced data: \verb~sim2chro~ and \verb~gnuplot-rif~}
\label{sec-2-3}
\begin{itemize}

\item Generate a RIF file\\
\label{sec-2-3-1}%
It is  possible to store the lutin  RIF output into a  file using the
\verb~-o~ option.



\href{file:./sh/rif-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin -l 10 -o ten.rif N.lut ; ls -lh ten.rif}}} 




\pause


\item Visualize a  RIF file\\
\label{sec-2-3-2}%
\href{file:./sh/cat-demo.sh}{\texttt{\color{DarkGreen}{<prompt> cat ten.rif}}} 


\pause


\item Visualize a  RIF file (bis)\\
\label{sec-2-3-3}%
\href{file:./sh/sim2chro-demo.sh}{\texttt{\color{DarkGreen}{<prompt> cat ten.rif | sim2chrogtk -ecran > /dev/null}}} 

\pause


\item Visualize a  RIF file (ter)\\
\label{sec-2-3-4}%
\href{file:./sh/gnuplot-demo.sh}{\texttt{\color{DarkGreen}{<prompt> gnuplot-rif ten.rif}}} 


\end{itemize} % ends low level
\end{frame}
\begin{frame}
\frametitle{Automatic stimulation of Lutin programs}
\label{sec-2-4}


CANNOT INCLUDE FILE ./decr.lut



\href{file:./sh/lurette-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lurettetop -go -l 20 -rp "sut:lutin:incr.lut:incr" -rp "env:lutin:decr.lut:decr"}}} 



\pause 



\includegraphics[width=8.5cm]{jpg/geluck-echec.jpg}

\begin{itemize}
\item I've bought 2 electronic chess games
\item connected one to another
\item And now I have peace
\end{itemize}

  
\end{frame}
\section{The Language}
\label{sec-3}
\begin{frame}[fragile]
\frametitle{Back to programs of Section 1}
\label{sec-3-1}
\begin{itemize}

\item Let's come back to the Lutin  programs mentioned so far.\\
\label{sec-3-1-1}%
CANNOT INCLUDE FILE ./incr.lut

\end{itemize} % ends low level
\note{We said said That  the  first  one,  \href{file://.incr.lut}{incr.lut}  increments

      its input by one. Let's explain why.
}
\begin{itemize}

\item Those programs illustrate the 2 kinds of expressions we have in Lutin.
\label{sec-3-1-3}%
\begin{itemize}
\item \textbf{constraint  expressions} (\verb~y = x+1~) that  asserts facts outputs
  variables.
\item \textbf{trace expression} (\verb~loop~ <te>) that allows one to combine 
  constraint expressions.
\end{itemize}







\end{itemize} % ends low level
\end{frame}
\begin{frame}
\frametitle{Non deterministic programs}
\label{sec-3-2}
\begin{itemize}

\item A First non-deterministic program\\
\label{sec-3-2-1}%
CANNOT INCLUDE FILE ./trivial.lut



\href{file:./sh/trivial-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin -l 10 -q trivial.lut}}} 


\pause

\item It is possible to set the variable range at declaration time,\\
\label{sec-3-2-2}%
as done in \href{file://.trivial2.lut}{trivial2.lut}:

CANNOT INCLUDE FILE ./trivial2.lut




\href{file:./sh/trivial2-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin -l 10 -q trivial2.lut}}} 



\end{itemize} % ends low level
\end{frame}
\begin{frame}
\frametitle{Non deterministic programs (cont)}
\label{sec-3-3}


 Now consider the \href{file://.range.lut}{range.lut} program:

CANNOT INCLUDE FILE ./range.lut



\href{file:./sh/range-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin range.lut -l 10 -q}}} 


\begin{itemize}
\item Linear constraints $\to$ union  of convex polyhedra
\item Several heuristics are defined to perform the solution  draw
\end{itemize}

\begin{itemize}
\item \texttt{-{}-step-inside} (\texttt{-si}): draw inside the polyhedra 
  (the default)
\item \texttt{-{}-step-vertices} (\texttt{-sv}) draw among the polyhedra vertices
\item \texttt{-{}-step-edges} (\texttt{-se}): promote edges
\end{itemize}




\href{file:./sh/range-sv-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin range.lut -l 10 -q --step-vertices}}} 


\pause
\begin{itemize}
\item \href{file://.range2.lut}{Question}: write  a simpler  program than \href{file://.range.lut}{range.lut}  that behaves
\end{itemize}
the same.
\end{frame}
\begin{frame}
\frametitle{Non deterministic programs (cont)}
\label{sec-3-4}


\begin{itemize}
\item A 3D non-deterministic example
\end{itemize}



CANNOT INCLUDE FILE ./polyhedron.lut



\href{file:./sh/poly-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin polyhedron.lut -l 1000 -q > poly.data;\\ 
echo 'set point 0.2;set term wxt persist;splot "poly.data" using 1:2:3'| gnuplot}}} 








\begin{itemize}
\item One   can   observe   the    effect   of  
    \href{file:./sh/poly-se-demo.sh}{\texttt{\color{DarkGreen}{--step-edges}}}
\end{itemize}
and
\href{file:sh/poly-sv-demo.sh}{\texttt{\color{DarkGreen}{--step-vertices}}}          
options on the repartition of generated points
\end{frame}
\begin{frame}[fragile]
\frametitle{Non deterministic programs (cont)}
\label{sec-3-5}



Constraint   may   also  depend   on   inputs.   Try   to  play   the
\href{file://.range-bis.lut}{range-bis.lut} program:

CANNOT INCLUDE FILE ./range-bis.lut


\href{file:./sh/range-bis-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin range-bis.lut -luciole}}} 


The  major  difference with  \href{file://.range.lut}{range.lut}  is  that the  constraint
expression \verb~0  <= y and  y <= i~  is not always satisfiable.   If one
enters a negative value, that program will stop.
\end{frame}
\begin{frame}[fragile]
\frametitle{Controlled non-determinism: the choice operator}
\label{sec-3-6}

CANNOT INCLUDE FILE ./choice.lut



\href{file:./sh/choice-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin -l 10 -q choice.lut}}} 

\pause
It is possible to favor one branch over the other using 
weight directives (\texttt{:3}):

CANNOT INCLUDE FILE ./choice2.lut

In \href{file://.choice2.lut}{choice2.lut}, \verb~x=42~ is chosen with a probability of 3/4.




\href{file:./sh/choice2-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin -l 10000 -q choice2.lut | grep 42 | wc -l}}} 
\end{frame}
\begin{frame}
\frametitle{Controlled non-determinism: the choice operator}
\label{sec-3-7}


CANNOT INCLUDE FILE ./choice3.lut


\href{file:./sh/choice3-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin -luciole choice3.lut}}} 
\end{frame}
\begin{frame}
\frametitle{Combinators}
\label{sec-3-8}


 A \emph{combinator} is a well-typed  macro that eases code reuse.  
 One can define  a combinator with the \texttt{let/in}  statement, or just
 \texttt{let} for top-level combinators.
\begin{itemize}

\item A simple combinator\\
\label{sec-3-8-1}%
CANNOT INCLUDE FILE ./letdef.lut



\href{file:./sh/letdef-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin -quiet letdef.lut}}} 


\end{itemize} % ends low level
\end{frame}
\begin{frame}
\frametitle{A parametric combinator}
\label{sec-3-9}


The \href{file://.combinator.lut}{combinator.lut} program illustrates the use of parametric combinators:

CANNOT INCLUDE FILE ./combinator.lut



\href{file:./sh/combinator-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin -l 100 combinator.lut -o walk.rif ; gnuplot-rif walk.rif}}} 
\end{frame}
\begin{frame}
\frametitle{Combinators  (cont)}
\label{sec-3-10}
\begin{itemize}

\item A combinator that needs memory   (\texttt{ref})\\
\label{sec-3-10-1}%
CANNOT INCLUDE FILE ./up-and-down.lut



\href{file:./sh/up-and-down-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin -luciole up-and-down.lut}}} 



\pause 

Question: what  happens if you  guard the \texttt{up} combinator  by \texttt{x<max}
instead of \texttt{pre x < max}?


\end{itemize} % ends low level
\end{frame}
\begin{frame}[fragile]
\frametitle{Local variables}
\label{sec-3-11}

   
Sometimes,  it is  useful to  use  auxiliary variables  that are  not
output  variables.    Such  variables  can  be   declared  using  the
\verb~exist/in~    construct.    Its   use    is   illustrated    in   the
\href{file://.true_since_n_instants.lut}{true\_since\_n\_instants.lut} program:

CANNOT INCLUDE FILE ./true$_{\mathrm{since}}$$_n$$_{\mathrm{instants}}$.lut


\href{file:./sh/true-since-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin true\_since\_n\_instants.lut -luciole}}} 
\end{frame}
\begin{frame}
\frametitle{Local variables again}
\label{sec-3-12}

Local variables  can also  plain random  variables, as
illustrated the \href{file://.local.lut}{local.lut} program:



CANNOT INCLUDE FILE ./local.lut




\href{file:./sh/local-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin local.lut -l 100 -o local.rif ; gnuplot-rif local.rif}}} 


\begin{itemize}
\item Question: modify  the previous program  so that x reaches  the target
    after a \href{file:///home/jahier/lurette/doc/lutin-tuto/png/Screenshot-Gnuplot-localbis.png}{damped oscillation}
\end{itemize}
\href{file://.local-bis.lut}{Answer}
\end{frame}
\begin{frame}[fragile]
\frametitle{Distribute a constraint into a scope: \texttt{assert}}
\label{sec-3-13}



Consider for instance  the  \href{file://.true_since_n_instants2.lut}{true\_since\_n\_instants2.lut} program:

CANNOT INCLUDE FILE ./true$_{\mathrm{since}}$$_n$$_{\mathrm{instants2}}$.lut

\begin{itemize}
\item One flaw is that \verb~res = (b and (cpt<=0))~ is duplicated.
\end{itemize}

 
\begin{itemize}
\item \verb~assert <ce> in <te>~ $\equiv$ \verb~<te'>~, 

     where <te'>= <te>[c/c and ce]$_{\forall c \in \mathcal{C}onstraints(te)}$
\end{itemize}


\begin{itemize}
\item Question : Rewrite the \href{file://.true_since_n_instants2.lut}{true\_since\_n\_instants2.lut} using the
   \verb~assert/in~ construct and avoid code duplication.

 \href{file://.true_since_n_instants3.lut}{Answer}
\end{itemize}
\end{frame}
\begin{frame}
\frametitle{External code}
\label{sec-3-14}


Lutin program can call any function defined in a shared library (\texttt{.so})






\href{file:./sh/ext-call-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin -L libm.so -l 200 ext-call.lut -o f.rif;gnuplot-rif f.rif}}} 
\end{frame}
\begin{frame}[fragile]
\frametitle{Exceptions}
\label{sec-3-15}
\begin{itemize}

\item Global exceptions can be declared outside the main node:\\
\label{sec-3-15-1}%
\lstset{language=lutin}
\begin{lstlisting}
exception ident
\end{lstlisting}


\item or locally within a trace statement:\\
\label{sec-3-15-2}%
\lstset{language=lutin}
\begin{lstlisting}
exception ident in st
\end{lstlisting}


\item An existing  exception ident can  be raised with the  statement:\\
\label{sec-3-15-3}%
\lstset{language=lutin}
\begin{lstlisting}
raise ident
\end{lstlisting}


\item An exception can be caught with the statement:\\
\label{sec-3-15-4}%
\lstset{language=lutin}
\begin{lstlisting}
catch ident in st1 do st2
\end{lstlisting}

If the exception is raised  in st1, the control immediatelly passes to
st2. If the ``do'' part is omitted, the statement terminates normally.

\end{itemize} % ends low level
\end{frame}
\begin{frame}[fragile]
\frametitle{Exceptions (cont)}
\label{sec-3-16}


\begin{itemize}
\item The predefined Deadlock exception can only be catched
\end{itemize}


\lstset{language=lutin}
\begin{lstlisting}
catch Deadlock in st1 do st2
\end{lstlisting}
$\equiv$

\lstset{language=lutin}
\begin{lstlisting}
try st1 do st2
\end{lstlisting}


\begin{itemize}
\item If a deadlock is raised during the execution of st1, the control
  passes immediately to st2.   If st1 terminates normally, the whole
  statement terminates and the control passes to the sequel.
\end{itemize}
\end{frame}
\begin{frame}
\frametitle{Exceptions (cont)}
\label{sec-3-17}






\href{file:./sh/except-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin except.lut -luciole}}} 


Note that the 43 value is never generated (if i<>43 of course).
\end{frame}
\begin{frame}
\frametitle{About exceptions}
\label{sec-3-18}

\begin{itemize}
\item Very (too?) powerful mechanism
\item Can be used to build complex trace operators
\item But should they used to program?
\end{itemize}
\end{frame}
\begin{frame}
\frametitle{Parallelism: \texttt{\&>}}
\label{sec-3-19}



CANNOT INCLUDE FILE ./paralel.lut



\href{file:./sh/para-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin -luciole paralel.lut}}} 
 

nota bene: this construct can be expensive because of: 
\begin{itemize}
\item \textbf{the  control  structure}: such  a  product is  equivalent to  an
  automata product, which, in the worst case, can be quadratic;
\item \textbf{the  data}:  the  polyhedron resolution  is  exponential in  the
  dimension of the polyhedron.
\end{itemize}
  
Use the \texttt{run/in} construct instead if performance is a problem.
\end{frame}
\begin{frame}[fragile]
\frametitle{Combinators (again)}
\label{sec-3-20}
\begin{itemize}

\item Trace Combinators\\
\label{sec-3-20-1}%
\lstset{language=lutin}
\begin{lstlisting}
let myloop(t:trace) : trace = loop try loop t
\end{lstlisting}

Here we restart the loop from the beginning whenever we are
blocked somewhere inside \texttt{t}. (\href{file://.myloop.lut}{myloop.lut})

CANNOT INCLUDE FILE ./myloop.lut


\href{file:./sh/myloop-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin -luciole myloop.lut}}} 






\end{itemize} % ends low level
\end{frame}
\section{A new operator \texttt{run/in}}
\label{sec-4}
\begin{frame}[fragile]
\frametitle{Cheap parallelism: Calling Lutin nodes \texttt{run/in}}
\label{sec-4-1}


 The idea  is the following: when one writes:


\lstset{language=lutin}
\begin{lstlisting}
run (x,y) := foo(a,b) in
\end{lstlisting}

in order to be accepted the following rules must hold:
\begin{itemize}
\item \texttt{a} and \texttt{b} be uncontrollable variables (e.g., inputs or memories)
\item \texttt{x} and \texttt{y} should be controllable variables (e.g., outputs or locals)
\item in the scope of such a \texttt{run/in}, \texttt{x} and \texttt{y} becomes uncontrollable.
\end{itemize}
 
\pause
nb : it is exactly the parallelism of Lustre, with an heavier syntax.
In Lustre, one would simply write 

\lstset{language=lustre}
\begin{lstlisting}
(x,y)=foo(a,b);
\end{lstlisting}

Moreover in Lutin, the order of equations matters.
\end{frame}
\begin{frame}
\frametitle{Cheap parallelism: Calling Lutin nodes \texttt{run/in}}
\label{sec-4-2}


\begin{itemize}
\item The \texttt{run/in} construct is another (cheaper) way of executing code in parallel
\item The only way of calling Lutin nodes.
\item Less powerful: constraints are not merged, but solved in sequence
\end{itemize}

CANNOT INCLUDE FILE ./run.lut



\href{file:./sh/run-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin -l 5 -q run.lut -m use\_run}}} 






\#** Nodes versus combinators 
   
\end{frame}
\begin{frame}
\frametitle{Why does the \texttt{run/in} statement makes Lutin usable?}
\label{sec-4-3}

   
Using combinators and \texttt{\&>}, it was already possible to reuse code, but
\texttt{run/in} is

\begin{itemize}
\item Much more efficient: polyhedra dimension is smaller
\end{itemize}
  
\#Consider this example : xxx

\begin{itemize}
\item Mode-free (args can be in or out) combinators are error-prone
\end{itemize}
\#Consider this example : xxx

 
\end{frame}
\section{Advanced examples}
\label{sec-5}

    
\begin{frame}
\frametitle{Wearing sensors}
\label{sec-5-1}


The \href{file://.sensors.lut}{sensors.lut}  program that  makes extensive use  fo the
run statements.



\href{file:./sh/sensors-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin sensors.lut -m main -luciole}}} 
\end{frame}
\begin{frame}
\frametitle{Waiting for the stability of a signal}
\label{sec-5-2}



\begin{itemize}
\item Defining and checking the stability of a variable (in particular in
  presence of noise) is not that easy.
\item One  definition could be that  a variable is stable  if it remains
  within  an  interval  during  a  certain  amount  of  time.   More
  precisely:
\end{itemize}


\begin{quote}
A variable V  is (d,$\epsilon$)-stable at instant i  if there exists an
interval I of size $\epsilon$, such that, for all n in [i-d,i], V(n) is
in I.

$\exists$ I, st |I| = $\epsilon$, $\forall$ n $\in$ [i-d, i] V(n) $\in$ I
\end{quote}



\href{file://.is_stable.lut}{The Lutin version}



\href{file:./sh/is_stable-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lutin -luciole is\_stable.lut -m is\_stable}}} 
\end{frame}
\begin{frame}
\frametitle{The Crazzy rabbit}
\label{sec-5-3}

 
\begin{itemize}
\item The rabbit serves as an environment for a caml program
  that displays its position in a graphical windows
\item The rabbit remains in its field, and avoids a moving obstable
\item The rabbit changes it speed an trajectory from times to times
\end{itemize}



\href{file:sh/rabbit-demo.sh}{\texttt{\color{DarkGreen}{<prompt> lurettetop -rp "sut:ocaml:rabbit.cmxs:" -rp 'env:lutin:rabbit.lut:-main:rabbit:-L:libm.so:-loc'}}} 


\begin{itemize}
\item \href{file:///home/jahier/lurette/doc/lutin-tuto/crazy-rabbit/ud.lut}{crazy-rabbit/ud.lut}
\item \href{file:///home/jahier/lurette/doc/lutin-tuto/crazy-rabbit/moving-obstacle.lut}{crazy-rabbit/moving-obstacle.lut}
\item \href{file:///home/jahier/lurette/doc/lutin-tuto/crazy-rabbit/rabbit.lut}{crazy-rabbit/rabbit.lut}
\item \href{file:///home/jahier/lurette/doc/lutin-tuto/crazy-rabbit/rabbit.ml}{crazy-rabbit/rabbit.ml}
\end{itemize}

  
\end{frame}

\end{document}
